<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2005 Niels Behrendt (info@make-it-typo3.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'b.it Pagemenu' for the 'bit_pagemenu' extension.
 *
 * @author	Niels Behrendt <info@make-it-typo3.de>
 */

// Last updated 13.07.2011 Joern Dost@dt-internet.de

require_once(PATH_tslib.'class.tslib_pibase.php');

class tx_bitpagemenu_pi1 extends tslib_pibase {
	var $prefixId = 'tx_bitpagemenu_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_bitpagemenu_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'bit_pagemenu';	// The extension key.
	var $pi_checkCHash = TRUE;
	var $markerArray=array();

	/**
	 * [Put your description here]
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->internal['orderBy']="sorting";
		$this->internal['orderByList']="sorting";
		$this->internal['results_at_a_time']=$this->conf['results_at_a_time'];
		//Hole Template
		$this->tmpl =$this->cObj->fileResource($this->conf["file."]["templateFile"]);
		//Checke PidList (typoscript/pages/pid der seite)
		$this->conf["pidList"]=$this->conf["pidList"]?$this->conf["pidList"]:($this->cObj->data[pages]?$this->cObj->data[pages]:$this->cObj->data[pid]);

		//Get subpages
		
		// Patched by Joern Dost@dt-internet.de 12.07.2011:
		// Wenn mehrere Seiten ausgewaehlt wurden, dann werden diese Elemente (und nicht deren Unterseiten) angezeigt:
		if (stristr($this->conf["pidList"], ',')) {
			$res = $this->pi_exec_query("pages",0,"", "", "", "", "FROM pages WHERE uid IN (".$this->conf['pidList'].") ".$this->cObj->enableFields('pages'));
		// Sonst dagegen bleibt das alte query (hole alle Seiten mit dieser pid)
		} else {
  			$res = $this->pi_exec_query("pages",0,"AND pid = ".$this->conf["pidList"]);
		}
		// End of patch
		
		//get Teasercontent
		$this->conf["pidList"]=0;
		$exclude=t3lib_div::trimExplode(",",$this->conf['excludUIDs']);
		while ($part=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){ 
			$UID=$part['uid'];
			
			if (!in_array($UID,$exclude) && $part['doktype']!=7){
				$pagetitle[$UID]=$part['title'];
				$pagetext[$UID]=$part['abstract'];
				$pageimage[$UID]=$part['media'];
				$this->conf["pidList"].=",".$UID;
		
				}
			elseif($part['doktype']==7){
				//MOUNT-Seite
				$mp=$this->pi_getRecord('pages',$part['mount_pid']);
				$pagetitle[$mp['uid']]=$part['title'];
				$pagetext[$mp['uid']]=$mp['abstract'];
				$pageimage[$mp['uid']]=$mp['media'];
				$this->conf["pidList"].=",".$mp["uid"];
				$orgid[$mp['uid']]=",".$UID;
				}
			//GET TRANSLATED SUBPAGES
			
			}
		
		$res2=$this->pi_exec_query("tt_content",0,' AND sys_language_uid='.$GLOBALS['TSFE']->sys_language_uid);
			
			while ($content=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res2)){
				
				if ($content['bodytext']) $text[$content['pid']][]=$content['bodytext'];
				if ($content['header']) $headline[$content['pid']][]=$content['header'];
				if ($content['image']) $pic[$content['pid']][]=$content['image'];
				
				}
		
		$template= $this->cObj->getSubpart($this->tmpl,"###TEASERMENU###");
		
		$out = $this->cObj->substituteMarkerArray($template,$this->markerArray);
		while (list($id,$title)=each($pagetitle)){
			$tmpString=false;
			$oki=true;
				if ($GLOBALS['TSFE']->sys_language_uid) {
					$lang=$this->pi_exec_query('pages_language_overlay',1,' and sys_language_uid='.$GLOBALS['TSFE']->sys_language_uid.' and pid='.$id);
					list($trans)=$GLOBALS['TYPO3_DB']->sql_fetch_row($lang);
					if (!$trans){
						//print "nix gefunden fr ".$title."<br>";
						$oki=false;
						}
					}
				if ($oki){
			
			$output = $this->cObj->getSubpart ( $out, '###PAGE###' );
			if ($pic[$id][0]){
				$img=t3lib_div::trimExplode(",",$pic[$id][0]);
				$path="uploads/pics/";
				}
			else{
				$img=t3lib_div::trimExplode(",",$pageimage[$id]);
				$path="uploads/media/";
				}
			$markerArray["###IMAGE###"]="";
			$this->conf['countPic']=1;
			for ($x=0;$x<$this->conf['countPic'];$x++){
				if ($img[$x]){
					$IMAGE="";
					$IMAGE["file"]=$path.$img[$x];
					// Patched by Joern Dost@dt-internet.de 12.07.2011:
					// Ueber die TypoScript-SetupVariable pic.linkToArticle kann man steuern,
					// ob das Bild auf eine Grossansicht (default/0) oder auf den eigentlichen
					// Artikel (1) verlinken soll:
					if ($this->conf['pic.']['linkToArticle']==0) {
  					    $IMAGE["imageLinkWrap"]=1; 
  					} else {
  					    $IMAGE["imageLinkWrap"]=0;
  					}
  					// EndOfPatch (geht unten noch weiter)
  					
					$IMAGE["imageLinkWrap."]["width"]="800m";
					$IMAGE["imageLinkWrap."]["height"]="600m";
					$IMAGE["imageLinkWrap."]["enable"]="1";
					$IMAGE["imageLinkWrap."]["JSwindow."]["expand"]="0,0";
					$IMAGE["imageLinkWrap."]["bodyTag"]='<body bgcolor="#000000" leftmargin="0" topmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">';
					$IMAGE["imageLinkWrap."]["title"]="Bildvergrerung";
					$IMAGE["imageLinkWrap."]["wrap"]='<a onClick="self.close()">|</a>';
					$IMAGE["imageLinkWrap."]["JSwindow"]="1";
					$IMAGE["file."]["width"]=$this->conf['pic.']['maxWidth'];
					$IMAGE["file."]["height"]=$this->conf['pic.']['maxHeight'];

					$markerArray["###IMAGE###"].=$this->cObj->wrap($this->cObj->IMAGE($IMAGE),$this->conf['pic.']["imagewrap"]);
					}
				}

			// Patched by Joern Dost@dt-internet.de 12.07.2011:
			// Teaser-Kaesten bekommen abwechselnd eine even/odd-CSS-Klasse,
			// damit z.B. links/rechts-Darstellung moeglich ist.
			$GLOBALS["TSFE"]->fe_user->sesData['bitpagemenu_counter']++;
			if($GLOBALS["TSFE"]->fe_user->sesData['bitpagemenu_counter'] % 2 != 0){
          		  $markerArray["###CLASS###"]="odd";
          		}else{
          		  $markerArray["###CLASS###"]="even";
          		}
          		// EndOfPatch
          		
			$markerArray["###IWIDTH###"]=$this->conf['pic.']['maxWidth'];
			$markerArray["###TITLE###"]=$headline[$id][0]?$headline[$id][0]:$title;
			if ($text[$id][0]){
			  $tmpString=$this->cObj->crop($text[$id][0],$this->conf['textLength']);
			  // Patched by Joern Dost@dt-internet.de
			  // Anzeige des Teaser-Textes des ersten CE funktioniert nicht.
			  // Die folgende Zeile scheint irgend ein Entwicklungs-Rest zu sein
			  // (im naechsten if war sie bereits auskommentiert), darum raus damit:
			  //$tmpString=substr($tmpString,strpos($tmpString,'productteaser'-13),strpos($tmpString,'</p>'));
				$markerArray["###TEXT###"]=$tmpString;
				}
			if (!$tmpString || trim($tmpString)==""){
			  $tmpString=$this->cObj->crop($pagetext[$id],$this->conf['textLength']);
			  //$tmpString=substr($tmpString,strpos($tmpString,'productteaser'-13),strpos($tmpString,'</p>'));
				$markerArray["###TEXT###"]=$tmpString;
				}
				
			// Patched by Joern Dost@dt-internet.de 13.07.2011:
			// HTML-Tags entfernen, da einerseits nicht erwuenscht und andererseits
			// evtl. nicht zugemacht, weil der Teaser-Text ja nach X Zeichen abgebrochen wird
			$markerArray["###TEXT###"] = strip_tags($markerArray["###TEXT###"]);
			
			if ($orgid[$id]) $id=$orgid[$id];
			$markerArray["###LINK###"]=$this->pi_linkToPage($this->pi_getLL("bit_pagemenu.detail",">> Details"),$id,$this->conf["target"]);
			$markerArray["###PURELINK###"]=$this->pi_getPageLink($id,$this->conf["target"]);
			
			// Patched by Joern Dost@dt-internet.de 12.07.2011
			// Wenn pic.linkToArticle gesetzt ist, dann das Bild auf den Artikel linken
			// (siehe auch oben)
         	        if ($this->conf['pic.']['linkToArticle']==1) {
				$markerArray["###IMAGE###"]=$this->pi_linkToPage($markerArray["###IMAGE###"],$id,$this->conf["target"]);
			}
			// EndOfPatch
			$subpartContent .= $this->cObj->substituteMarkerArrayCached ( $output, $markerArray );
			}
			}

		$out = $this->cObj->substituteSubpart ( $out, '###PAGES###', $subpartContent);
		return $this->pi_wrapInBaseClass($out);
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/bit_pagemenu/pi1/class.tx_bitpagemenu_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/bit_pagemenu/pi1/class.tx_bitpagemenu_pi1.php']);
}

?>
